function [ sinkIdx ] = find_sink( shifted_idx )
% Find sink for each node by traversals
% Minsu Cho, Seoul National University, 2009
%
% input : shifted indexes 
% ouput : sink indexes

sinkIdx = zeros(size(shifted_idx));
nNode = length(shifted_idx);

% Traverse for each node
for i = 1:nNode
    [ sinkIdx ] = find_sink_recur( i, shifted_idx, sinkIdx );
end

end

function [ sinkIdx ] = find_sink_recur( cur_idx, shifted_idx, sinkIdx )

if cur_idx == shifted_idx(cur_idx) % if a sink
    sinkIdx(cur_idx) = cur_idx;
else
    if sinkIdx(shifted_idx(cur_idx)) == 0 % if not labelled, dive into recursion
        sinkIdx(cur_idx) = cur_idx; % footmark for a cyclic sink
        sinkIdx = find_sink_recur(shifted_idx(cur_idx), shifted_idx, sinkIdx );
    end
    sinkIdx(cur_idx) = sinkIdx(shifted_idx(cur_idx)); % inherit the sink label
end

end