function [W,distances] = compute_affinity(data, scale, order)
% [W,distances] = compute_affinity(data,scale_sig,order)
% Input: data as feature_dim x num of data
% Ouput: affinity matrix W as pair-wise data similarity matrix
%        distances as pair-wise Euclidean distance
%
% MInsu Cho 2009

distances  = dist(data); % distance matrix
if ~exist('scale')
    scale = 0.05*max(distances(:));
end
if ~exist('order')
    order = 2;
end

W = exp(-(distances/scale).^order);

