function plot2Dpoints_with_clusters_AP(points2D, cluster_assignment, bText, edge_add, color_vectorm)  
  
  bVisAttractor = 0;
  bVisEdge = 0;
  n=size(points2D,2);
  if n>0
    if (nargin < 2)
       bVisAttractor = 0;
       bVisEdge = 1;
       color_vector=['k.'];
       cluster_assignment = ones(n,1); 
       paramLineWidth = 1; paramMarkerSize = 5;
       paramLineWidthA = 2; paramMarkerSizeA = 8; 
    else
        paramLineWidthA = 2; paramMarkerSizeA = 7; 
        if (nargin < 4)
            edge_add = [];
            paramLineWidth = 1; paramMarkerSize = 7;        
        else
            paramLineWidth = 1; paramMarkerSize = 5;        
        end
        if (nargin < 5)
          color_vector=['ro'; 'bx'; 'g+'; 'ms'; 'c^'; 'kd' ];%'yv'
        end 
    end

    cluster_assignment = cluster_assignment(:)'; % row vector
    
    if (nargin < 3)
        bText = 0;            
    end
    
	hold_state=ishold;
	hold on
    clusterIdx = unique(cluster_assignment);
    clusterCol = rand(length(clusterIdx),3);
    
    % show shifting edge
%     if size(edge_add,2) > 0
%         targetIdx = unique(edge_add(2,:));
%         for tIdx = targetIdx
%             idxElements = find( edge_add(2,:) == tIdx );
%             line([points2D(1,edge_add(1,idxElements)); points2D(1,edge_add(2,idxElements))],...
%               [points2D(2,edge_add(1,idxElements)); points2D(2,edge_add(2,idxElements))],'Color',rand(1,3));
%         end
%     end
%     szElements = [];
%     for i=1:length(clusterIdx)
%         idxElements = find( cluster_assignment == clusterIdx(i) );
%         szElements(i) = length(idxElements);
%     end
%     [ tmp sortedIdx ] = sort(szElements,'descend');
    sortedIdx = 1:length(clusterIdx);
    for i=1:length(clusterIdx)  
      idxElements = find( cluster_assignment == clusterIdx(sortedIdx(i)) );
      if i<= length(color_vector)
		fstring=color_vector(i,:);
        plot(points2D(1,idxElements),points2D(2,idxElements),fstring);
      else
        color_c = clusterCol(i,:);
        plot(points2D(1,idxElements),points2D(2,idxElements),'*','color',color_c);
      end
      
    end
    
    if bVisEdge %show all edges
        idxCore = unique(cluster_assignment);
        for iIdx = idxCore
            for jIdx = idxCore
                  line([points2D(1,iIdx); points2D(1,jIdx)],...
                  [points2D(2,iIdx); points2D(2,jIdx)],'LineStyle','-','LineWidth',1, 'color', 'k' );
            end
        end
    end
    
    if bVisAttractor
        for i=1:length(clusterIdx)  
          if i<= length(color_vector)
            fstring=color_vector(i,:);
            plot(points2D(1,clusterIdx(sortedIdx(i))),points2D(2,clusterIdx(sortedIdx(i))),'o','MarkerEdgeColor','k',...
                'MarkerFaceColor',fstring(1), 'LineWidth',paramLineWidthA,'MarkerSize',paramMarkerSizeA);
          else
            color_c = clusterCol(i,:);
            plot(points2D(1,clusterIdx(sortedIdx(i))),points2D(2,clusterIdx(sortedIdx(i))),'o','MarkerEdgeColor','k',...
                'MarkerFaceColor',color_c, 'LineWidth',paramLineWidthA,'MarkerSize',paramMarkerSizeA);
          end      
        end
    end
    
    if bText == 1
      for k = 1:n
           text(points2D(1,k),points2D(2,k),['  ' num2str(k)],'Color','k','FontSize',15,'FontWeight','b')
      end
    elseif bText == 2
      for k = 1:length(clusterIdx)
           text(points2D(1,clusterIdx(k)),points2D(2,clusterIdx(k)),['  ' num2str(k)],'Color','k','FontSize',15,'FontWeight','b')
      end
    end
    
	% restore the hold state as before
	if (~hold_state)
	  hold off 
	end
	
  end
  